<?php
class av42v_akismet extends bv42v_base {
	public function verify_key($key) {
		$api_host = 'rest.akismet.com';
		$blog = get_option ( 'home' );
		$data = array ("key" => $key, "blog" => $blog );
		$http = new bv42v_http ( "http://" . $api_host . '/1.1/verify-key' );
		$http->data ( $data );
		$http->method ( 'POST' );
		$response = $http->get ();
		if ('valid' == $response) {
			return true;
		} else {
			
			return false;
		}
	}
	private $spam = null;
	private function _check($name, $email, $data) {
		if (is_array ( $data )) {
			$data = implode ( "\n", $data );
		}
		$key = $this->data ( '_keys' )->akismet_keys ['api_key'];
		$api_host = $key . '.rest.akismet.com';
		$commentdata = array ('permalink' => get_permalink (), 'comment_author' => $name, 'comment_author_email' => $email, 'comment_content' => $data );
		$comment = $commentdata;
		$comment ['user_ip'] = $_SERVER ['REMOTE_ADDR'];
		$comment ['user_agent'] = $_SERVER ['HTTP_USER_AGENT'];
		$comment ['referrer'] = $_SERVER ['HTTP_REFERER'];
		$comment ['blog'] = get_option ( 'home' );
		$comment ['blog_lang'] = get_locale ();
		$comment ['blog_charset'] = get_option ( 'blog_charset' );
		$ignore = array ('HTTP_COOKIE', 'HTTP_COOKIE2', 'PHP_AUTH_PW' );
		foreach ( $_SERVER as $key => $value )
			if (! in_array ( $key, $ignore ) && is_string ( $value ))
				$comment ["$key"] = $value;
			else
				$comment ["$key"] = '';
		global $wp_version;
		$http = new bv42v_http ( 'http://' . $api_host . '/1.1/comment-check' );
		$http->addHeader ( 'User-Agent', "WordPress/$wp_version | " . $this->application ()->name . '/' . $this->application ()->version );
		$http->data ( $comment );
		$http->method ( 'POST' );
		$result = $http->get ();
		$this->spam = ($result == 'true');
		return $this->spam;
	}
	public function check($name, $email, $data) {
		if (null === $this->spam) {
			if ($this->data ( '_keys' )->akismet_keys ['api_key'] != '') {
				$this->_check ( $name, $email, $data );
			}
		}
		return $this->spam;
	}
}