<?php
class sv42v_controller_settings extends wv42v_controller_action_pluginsandbox {
	public function controller_meta() {
		$return = parent::controller_meta ();
		//$return ['title'] = 'FormPlugins';
		$return ['menu'] = 'Settings';
		$return ['slug'] = $this->application ()->slug;
		return $return;
	}
	/*	public function NoticesActionMeta($return)
	{
		$return['priority']=99;
		$return['notice']= 'Important notice about your form settings.';
		$this->clear_notice('Notices','2011-02-05 16:18');
		return $return;
	}
	public function NoticesAction($content)
	{
		$this->read_notice();
		$page = $this->render_script ( 'common/Notices.phtml' );
		return $content.$page;
	}
*/
	public function field_type_helpActionMeta($return) {
		$return ['title'] = 'Field-type Help';
		$return ['hide'] = true;
		return $return;
	}
	public function field_type_helpAction($content) {
		$page = $this->render_script ( 'help/field-type-help.phtml' );
		return $content . $page;
	}
	public function __construct(&$application) {
		parent::__construct ( $application );
		$this->view->updated_class = 'updated';
	}
	public function AkismetActionMeta($return) {
		echo 'herehereherehereherehereherehereherehereherehereherehereherehereherehereherehereherehereherehereherehereherehereherehere';
		//if ( $this->settings ()->types['akismet'] ['allowed']!=1)
		{
			$return ['title'] = '';
		}
		return $return;
	}
	public function AkismetAction($content) {
		$akismet = new av42v_akismet ( $this->application () );
		if ($_SERVER ['REQUEST_METHOD'] == 'POST') {
			if (! empty ( $_POST ['api_key'] ) && ! $akismet->verify_key ( $_POST ['api_key'] )) {
				$_POST ['api_key'] = '';
				$this->view->updated = 'Invalid Key: Key has been removed';
				$this->view->updated_class = 'error';
			
			} else {
				$this->view->updated = 'Settings Updated';
				$this->view->updated_class = 'updated';
			}
		}
		$this->settings ()->set_options_name ( '_global' );
		$this->view->data = $this->settings ()->post ( 'akismet_keys' );
		$page = $this->render_script ( 'common/akismet.phtml' );
		return $content . $page;
	}
	public function reCAPTCHAActionMeta($return) {
		if (! in_array ( 'recaptcha', ( array ) $this->settings ()->formx ['types'] )) {
			$return ['title'] = '';
		}
		return $return;
	}
	public function reCAPTCHAAction($content) {
		$recaptcha = new av42v_recaptcha ( $this->application () );
		$this->settings ()->set_options_name ( '_global' );
		$this->view->data = $this->settings ()->post ( 'recaptcha_keys' );
		$this->view->signup_url = $recaptcha->signup_url ();
		$page = $this->render_script ( 'common/recaptcha.phtml' );
		return $content . $page;
	}
	public function settingsActionMeta($return) {
		$return ['priority'] = - 3;
		$return ['title'] = 'Forms';
		return $return;
	}
	public function getting_startedAction($content) {
		$page = $this->render_script ( 'common/getting_started.phtml' );
		return $content . $page;
	}
	public function settingsAction($content) {
		$this->view->obj_type = 'form';
		return parent::settingsAction ( $content );
	}
	public function _InstructionTitle() {
		echo '<span class="info" title="Place this code in your post to display the form">BBCode</span>';
	}
	public function _InstructionColumn() {
		if (! empty ( $this->view->location ['name'] ) && ! $this->settings ()->special_setting ( $this->view->location ['name'] )) {
			echo '[' . strtolower ( $this->settings ()->type () );
			if ($this->view->location ['name'] != 'default') {
				echo ' form="' . $this->view->location ['name'] . '"';
			}
			echo ']';
		}
	}
	public function settings_actionTitle() {
		echo 'Edit';
	}
	public function settings_instructionTitle() {
		echo '<span class=info title="Place the code in your post/page to display the form">BBCode</a>';
	}
	public function settings_instructionColumn() {
		echo '[' . $this->application ()->name;
		if ($this->view->location ['name'] != 'default') {
			echo " form='" . $this->view->location ['name'] . "'";
		}
		echo ']';
	}
	public function settings_actionColumn() {
		if (! empty ( $this->view->location ['name'] ) && ! $this->settings ()->special_setting ( $this->view->location ['name'] )) {
			$echo = array ();
			$echo [] = '<a  title="Basic form details." href = "' . $this->view->base_url . '&page2=FormsEdit&edit=' . urlencode ( $this->view->location ['name'] ) . '&section=General">General</a>';
			if ($this->settings ()->type () != 'QuizMe') {
				$echo [] = '<a title="How the data is to be used." href = "' . $this->view->base_url . '&page2=FormsEdit&edit=' . urlencode ( $this->view->location ['name'] ) . '&section=Data Collection">Data Collection</a>';
			}
			if ($this->settings ()->graphics ['do']) {
				$echo [] = '<a title="Set how the charted data should look." href = "' . $this->view->base_url . '&page2=FormsEdit&edit=' . urlencode ( $this->view->location ['name'] ) . '&section=Graphics">Graphics</a>';
			}
			$echo [] = '<a href = "' . $this->view->base_url . '&page2=FormsEdit&edit=' . urlencode ( $this->view->location ['name'] ) . '&section=Field Definitions">Field Definitions</a>';
			$echo [] = '<a  title="You are allowed to change some of the simpler responses here." href = "' . $this->view->base_url . '&page2=FormsEdit&edit=' . urlencode ( $this->view->location ['name'] ) . '&section=Responses">Responses</a>';
			echo implode ( ' | ', $echo );
		}
	}
	public function FormsEditActionMeta($return) {
		if (isset ( $_GET ['edit'] ) && isset ( $_GET ['section'] )) {
			$return ['title'] = 'Forms&raquo;Edit&raquo;' . $_GET ['edit'] . '&raquo;' . $_GET ['section'];
		}
		$return ['hide'] = true;
		return $return;
	}
	public function types($type) {
		$form = $this->settings ()->form_settings ();
		$types = $form ['types'];
		if (! in_array ( $type, $types )) {
			if ($type == "") {
				array_unshift ( $types, $type );
			} else {
				$types = array ($type );
			}
		}
		return $types;
	}
	public function FormsEditAction($content) {
		$ru = explode ( '?', $_SERVER ['REQUEST_URI'] );
		$this->view->url = 'http://' . $_SERVER ['HTTP_HOST'] . $ru [0] . '?page=' . $_GET ['page'];
		$this->settings ()->form ( $_GET ['edit'] );
		$section = strtolower ( str_replace ( ' ', '_', $_GET ['section'] ) );
		if ($section == 'responses') {
			$section = 'views';
		}
		$posted = $this->settings ()->post ( $section );
		switch ($section) {
			case 'general' :
				$this->view->general = $this->settings ()->general ();
				break;
			case 'data_collection' :
				$this->view->data_collection = $this->settings ()->data_collection ();
				break;
			case 'field_definitions' :
				$this->view->field_definitions = $this->settings ()->field_definitions ( true );
				break;
			case 'responses' :
				break;
			case 'graphics' :
				$this->view->graphics = $this->settings ()->graphics;
				break;
		}
		$this->view->page = $this->render_script ( 'common/formsedit/' . strtolower ( str_replace ( ' ', '-', strtolower ( $_GET ['section'] ) ) . '.phtml' ), false );
		$page = $this->render_script ( 'common/formsedit.phtml', false );
		$page = $this->updated ( 'Fields Updated' ) . $page;
		return $content . $page;
	}
}		