<?php
class survey_admin extends wv42v_action {
	/****************************************************************************************/
	public function initWPaction() {
		wp_register_script ( 'v42v_form_admin', $this->application ()->pluginuri () . '/library/survey/public/js/admin.js', null, $this->application ()->version () );
	}
	public function admin_print_scriptsWPaction() {
		wp_enqueue_script ( 'v42v_form_admin' );
		wp_localize_script ( 'v42v_form_admin', 'v42v_form_admin_data', $this->passed_data () );
	}
	private function passed_data() {
		$return = array ();
		return $return;
	}

//http://contactme.dcoda.co.uk/getting-started/
	public function getting_startedActionMeta($return) {
		$return ['link_name'] = $return ['title'];
		$return ['url'] = $this->help('gettingstarted')->url();
		$return ['classes'] [] = 'v42v_info';
		return $return;
	}
//	public function getting_startedAction() {
//		$page = $this->render_script ( 'common/getting_started.phtml' );
//		return $page;
//	}
	public function FormsEditActionMeta($return) {
		if (isset ( $_GET ['edit'] ) && isset ( $_GET ['section'] )) {
			$return ['title'] = 'Forms&raquo;Edit&raquo;' . $_GET ['edit'] . '&raquo;' . $_GET ['section'];
		}
		$return ['hide'] = true;
		return $return;
	}
	public function FormsEditAction() {
		$page = '';
		$section = $_GET ['section'];
		if ($section == 'responses') {
			$section = 'views';
		}
		$this->view->$section = $this->data ( $_GET ['edit'] )->post ( $section );
		$this->form()->active($_GET ['edit']);
		if ($section == 'field_definitions') {
			$this->view->page = $this->form ( $_GET ['edit'] )->admin_html ();
		} else {
			$this->view->page = $this->render_script ( "common/formsedit/{$section}.phtml", false );
		}
		$this->view->url = $this->dashboard ( 'Settings', $this->application ()->name )->url;
		$page = $this->render_script ( 'common/formsedit.phtml', false );
		return $page;
	}
	public function reCAPTCHAActionMeta($return) {
		if ($this->application ()->slug == 'quizme') {
			$return ['title'] = '';
		}
		return $return;
	}
/*	public function AkismetActionMeta($return) {
		if (in_array($this->application ()->slug ,array('quizme','pollme'))) {
			$return ['title'] = '';
		}
		return $return;
	}
	public function AkismetAction() {
		$akismet = new av42v_akismet ( $this->application () );
		if ($this->request ()->is_post ()) {
			if (isset ( $_POST ['akismet_keys'] ['api_key'] ) && ! $akismet->verify_key ( $_POST ['akismet_keys'] ['api_key'] )) {
				$_POST ['akismet_keys'] ['api_key'] = '';
				$this->update_message ( 'Invalid Key: Key has been removed', 'error' );
			
			}
		}
		$this->view->data = $this->data ( '_keys' )->post ( 'akismet_keys' );
		$page = $this->render_script ( 'common/akismet.phtml' );
		return $page;
	}
*/	public function reCAPTCHAAction() {
		$recaptcha = new av42v_recaptcha ( $this->application () );
		$this->view->data = $this->data ( '_keys' )->post ( 'recaptcha_keys' );
		$this->view->signup_url = $recaptcha->signup_url ();
		$page = $this->render_script ( 'common/recaptcha.phtml' );
		return $page;
	}
	public function field_type_helpActionMeta($return) {
		$return ['title'] = 'Field-type Help';
		$return ['hide'] = true;
		return $return;
	}
	public function field_type_helpAction($content) {
		$page = $this->render_script ( 'help/field-type-help.phtml' );
		return $content . $page;
	}
	public function settings_actionTitle() {
		return 'Edit';
	}
	public function settings_instructionTitle() {
		return '<span class=info title="Place the code in your post/page to display the form">BBCode</a>';
	}
	public function settings_instructionColumn() {
		$return = '';
		if (! empty ( $this->view->form ['name'] )) {
			$return .= '[' . $this->application ()->slug;
			if ($this->view->form ['name'] != 'default') {
				$return .= " form='" . $this->view->form ['name'] . "'";
			}
			$return .= ']';
		}
		return $return;
	}
	public function settings_actionColumn() {
		foreach ( $this->get_actions ( 'wpmenu' ) as $menu ) {
			break;
		}
		$baseUrl = $this->dashboard ( $menu ['menu'], $menu ['title'] )->url;
		if (! empty ( $this->view->form ['name'] )) {
			$echo = array ();
			$echo [] = '<a  title="Basic form details." href = "' . $baseUrl . '&page2=FormsEdit&edit=' . urlencode ( $this->view->form ['name'] ) . '&section=general">General</a>';
			if ($this->application ()->slug != 'quizme') {
				$echo [] = '<a title="How the data is to be used." href = "' . $baseUrl . '&page2=FormsEdit&edit=' . urlencode ( $this->view->form ['name'] ) . '&section=data_collection">Data Collection</a>';
			}
			if (in_array($this->application ()->slug, array( 'pollme'))) {
				$echo [] = '<a title="Set how the charted data should look." href = "' . $baseUrl . '&page2=FormsEdit&edit=' . urlencode ( $this->view->form ['name'] ) . '&section=graphics">Graphics</a>';
			}
			$echo [] = '<a href = "' . $baseUrl . '&page2=FormsEdit&edit=' . urlencode ( $this->view->form ['name'] ) . '&section=field_definitions">Field Definitions</a>';
			$echo [] = '<a  title="You are allowed to change some of the simpler responses here." href = "' . $baseUrl . '&page2=FormsEdit&edit=' . urlencode ( $this->view->form ['name'] ) . '&section=responses">Responses</a>';
			return implode ( ' | ', $echo );
		}
	}
	public function surveyWPmenuMeta($return) {
		$return ['menu'] = 'Settings';
		$return ['slug'] = $this->application ()->slug;
		$return ['title'] = $this->application ()->name;
		return $return;
	}
	public function FormsActionMeta($return) {
		$return ['link_name'] = $return ['title'];
		$return ['priority'] = - 1;
		return $return;
	}
	public function FormsAction() {
		$this->view->forms = $this->application ()->form ()->forms ();
		$this->view->has_tables = false;
		foreach ( $this->view->forms as $form ) {
			if (null !== $form ['table']) {
				$this->view->has_tables = true;
				break;
			}
		}
		return $this->render_script ( 'common/forms.phtml' );
	}
}		